summaryrefslogtreecommitdiff
path: root/plugins/extract/extract.plugin.zsh
diff options
context:
space:
mode:
authorMarc Cornellà <hello@mcornella.com>2021-08-14 22:03:41 +0200
committerMarc Cornellà <hello@mcornella.com>2021-08-14 22:34:14 +0200
commit0b32e4b25fa7f3215964281a8af4e3ff2bf4cd68 (patch)
tree2878ea3e33182362797069039e447e073bc06f50 /plugins/extract/extract.plugin.zsh
parent10a00085d027a969c7ef27e52085ca1fa7f5668c (diff)
downloadzsh-0b32e4b25fa7f3215964281a8af4e3ff2bf4cd68.tar.gz
zsh-0b32e4b25fa7f3215964281a8af4e3ff2bf4cd68.tar.bz2
zsh-0b32e4b25fa7f3215964281a8af4e3ff2bf4cd68.zip
style(extract): adopt main code style guide and refactor variables
Diffstat (limited to 'plugins/extract/extract.plugin.zsh')
-rw-r--r--plugins/extract/extract.plugin.zsh153
1 files changed, 74 insertions, 79 deletions
diff --git a/plugins/extract/extract.plugin.zsh b/plugins/extract/extract.plugin.zsh
index a257f6bc3..1112dd52f 100644
--- a/plugins/extract/extract.plugin.zsh
+++ b/plugins/extract/extract.plugin.zsh
@@ -1,90 +1,85 @@
alias x=extract
extract() {
- setopt localoptions noautopushd
+ setopt localoptions noautopushd
- local remove_archive
- local success
- local extract_dir
+ if (( $# == 0 )); then
+ cat >&2 <<'EOF'
+Usage: extract [-option] [file ...]
- if (( $# == 0 )); then
- cat <<-'EOF' >&2
- Usage: extract [-option] [file ...]
+Options:
+ -r, --remove Remove archive after unpacking.
+EOF
+ fi
- Options:
- -r, --remove Remove archive after unpacking.
- EOF
- fi
+ local remove_archive=1
+ if [[ "$1" == "-r" ]] || [[ "$1" == "--remove" ]]; then
+ remove_archive=0
+ shift
+ fi
- remove_archive=1
- if [[ "$1" == "-r" ]] || [[ "$1" == "--remove" ]]; then
- remove_archive=0
- shift
- fi
+ local pwd="$PWD"
+ while (( $# > 0 )); do
+ if [[ ! -f "$1" ]]; then
+ echo "extract: '$1' is not a valid file" >&2
+ shift
+ continue
+ fi
- local pwd="$PWD"
- while (( $# > 0 )); do
- if [[ ! -f "$1" ]]; then
- echo "extract: '$1' is not a valid file" >&2
- shift
- continue
- fi
+ local success=0
+ local extract_dir="${1:t:r}"
+ local file="$1" full_path="${1:A}"
+ case "${file:l}" in
+ (*.tar.gz|*.tgz) (( $+commands[pigz] )) && { pigz -dc "$file" | tar xv } || tar zxvf "$file" ;;
+ (*.tar.bz2|*.tbz|*.tbz2) tar xvjf "$file" ;;
+ (*.tar.xz|*.txz)
+ tar --xz --help &> /dev/null \
+ && tar --xz -xvf "$file" \
+ || xzcat "$file" | tar xvf - ;;
+ (*.tar.zma|*.tlz)
+ tar --lzma --help &> /dev/null \
+ && tar --lzma -xvf "$file" \
+ || lzcat "$file" | tar xvf - ;;
+ (*.tar.zst|*.tzst)
+ tar --zstd --help &> /dev/null \
+ && tar --zstd -xvf "$file" \
+ || zstdcat "$file" | tar xvf - ;;
+ (*.tar) tar xvf "$file" ;;
+ (*.tar.lz) (( $+commands[lzip] )) && tar xvf "$file" ;;
+ (*.tar.lz4) lz4 -c -d "$file" | tar xvf - ;;
+ (*.tar.lrz) (( $+commands[lrzuntar] )) && lrzuntar "$file" ;;
+ (*.gz) (( $+commands[pigz] )) && pigz -dk "$file" || gunzip -k "$file" ;;
+ (*.bz2) bunzip2 "$file" ;;
+ (*.xz) unxz "$file" ;;
+ (*.lrz) (( $+commands[lrunzip] )) && lrunzip "$file" ;;
+ (*.lz4) lz4 -d "$file" ;;
+ (*.lzma) unlzma "$file" ;;
+ (*.z) uncompress "$file" ;;
+ (*.zip|*.war|*.jar|*.ear|*.sublime-package|*.ipa|*.ipsw|*.xpi|*.apk|*.aar|*.whl) unzip "$file" -d "$extract_dir" ;;
+ (*.rar) unrar x -ad "$file" ;;
+ (*.rpm)
+ command mkdir -p "$extract_dir" && builtin cd -q "$extract_dir" \
+ && rpm2cpio "$full_path" | cpio --quiet -id ;;
+ (*.7z) 7za x "$file" ;;
+ (*.deb)
+ command mkdir -p "$extract_dir/control" "$extract_dir/data"
+ builtin cd -q "$extract_dir"; ar vx "$full_path" > /dev/null
+ builtin cd -q control; extract ../control.tar.*
+ builtin cd -q ../data; extract ../data.tar.*
+ builtin cd -q ..; command rm *.tar.* debian-binary ;;
+ (*.zst) unzstd "$file" ;;
+ (*.cab) cabextract -d "$extract_dir" "$file" ;;
+ (*.cpio) cpio -idmvF "$file" ;;
+ (*)
+ echo "extract: '$file' cannot be extracted" >&2
+ success=1 ;;
+ esac
- success=0
- extract_dir="${1:t:r}"
- local full_path="${1:A}"
- case "${1:l}" in
- (*.tar.gz|*.tgz) (( $+commands[pigz] )) && { pigz -dc "$1" | tar xv } || tar zxvf "$1" ;;
- (*.tar.bz2|*.tbz|*.tbz2) tar xvjf "$1" ;;
- (*.tar.xz|*.txz)
- tar --xz --help &> /dev/null \
- && tar --xz -xvf "$1" \
- || xzcat "$1" | tar xvf - ;;
- (*.tar.zma|*.tlz)
- tar --lzma --help &> /dev/null \
- && tar --lzma -xvf "$1" \
- || lzcat "$1" | tar xvf - ;;
- (*.tar.zst|*.tzst)
- tar --zstd --help &> /dev/null \
- && tar --zstd -xvf "$1" \
- || zstdcat "$1" | tar xvf - ;;
- (*.tar) tar xvf "$1" ;;
- (*.tar.lz) (( $+commands[lzip] )) && tar xvf "$1" ;;
- (*.tar.lz4) lz4 -c -d "$1" | tar xvf - ;;
- (*.tar.lrz) (( $+commands[lrzuntar] )) && lrzuntar "$1" ;;
- (*.gz) (( $+commands[pigz] )) && pigz -dk "$1" || gunzip -k "$1" ;;
- (*.bz2) bunzip2 "$1" ;;
- (*.xz) unxz "$1" ;;
- (*.lrz) (( $+commands[lrunzip] )) && lrunzip "$1" ;;
- (*.lz4) lz4 -d "$1" ;;
- (*.lzma) unlzma "$1" ;;
- (*.z) uncompress "$1" ;;
- (*.zip|*.war|*.jar|*.ear|*.sublime-package|*.ipa|*.ipsw|*.xpi|*.apk|*.aar|*.whl) unzip "$1" -d "$extract_dir" ;;
- (*.rar) unrar x -ad "$1" ;;
- (*.rpm)
- command mkdir -p "$extract_dir" && builtin cd -q "$extract_dir" \
- && rpm2cpio "$full_path" | cpio --quiet -id ;;
- (*.7z) 7za x "$1" ;;
- (*.deb)
- command mkdir -p "$extract_dir/control" "$extract_dir/data"
- builtin cd -q "$extract_dir"; ar vx "$full_path" > /dev/null
- builtin cd -q control; extract ../control.tar.*
- builtin cd -q ../data; extract ../data.tar.*
- builtin cd -q ..; command rm *.tar.* debian-binary ;;
- (*.zst) unzstd "$1" ;;
- (*.cab) cabextract -d "$extract_dir" "$1" ;;
- (*.cpio) cpio -idmvF "$1" ;;
- (*)
- echo "extract: '$1' cannot be extracted" >&2
- success=1
- ;;
- esac
+ (( success = success > 0 ? success : $? ))
+ (( success == 0 && remove_archive == 0 )) && rm "$full_path"
+ shift
- (( success = success > 0 ? success : $? ))
- (( success == 0 && remove_archive == 0 )) && rm "$full_path"
- shift
-
- # Go back to original working directory in case we ran cd previously
- builtin cd -q "$pwd"
- done
+ # Go back to original working directory in case we ran cd previously
+ builtin cd -q "$pwd"
+ done
}